<template>
  <div>
    <img class="logo" width="100%" src="../../assets/konsentlogo.jpg"/>

    <van-steps :active="step">
      <van-step>PIN-code</van-step>
      <van-step>Encrypt wallet</van-step>
      <van-step>Verification</van-step>
    </van-steps>

    <br>

    <div v-if="step == 0">
      <div class="pin-code">
        <p>Set up your PIN-code</p>
      </div>
      <van-password-input :value="password" @focus="showKeyboard = true"/>
      <van-number-keyboard :show="showKeyboard" @input="onInput" @delete="onDelete" @blur="showKeyboard = false"/>
      <br>
      <van-button type="primary" @click="createWallet" round class="konsent-button" ><span>Create Account</span></van-button>
    </div>

    <div v-if="step === 1">
      <van-notice-bar :text="mnemonic" mode="closeable" @click="toggleOtp"/>
    </div>

    <section v-if="step === 2">
      <div class="sms-section" >
        <p class="section-header">Verify your phone number to get started:</p>
        <p>1. Send SMS 'START' to <a href="sms:+4759446238">+47 594 46 238</a></p>
        <p>2. Receive SMS with verification token</p>
        <p>3. Fill in the form below</p>
      </div>
      <van-cell-group class="mt-2">
        <van-field
          v-model="phone"
          required
          clearable
          label="Phone:"
          right-icon="question-o"
          placeholder="+4797102265"
          @click-right-icon="$toast('Enter your valid phone number here')"
        />

        <van-field
          v-model="token"
          required
          clearable
          label="Token:"
          right-icon="question-o"
          placeholder=""
          @click-right-icon="$toast('Enter the token you received on your phone')"
        />

        <van-number-keyboard :show="showKeyboard" @input="onInput" @delete="onDelete" @blur="showKeyboard = false"/>
      </van-cell-group>

      <van-button type="primary" @click="validateToken" round class="konsent-button"><span>Complete setup</span></van-button>
    </section>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import { TRIGGER_WALLET_GENERATION, basePath } from './actions';
import { validateOtpInit } from '../otp/actions';
import names from '../../names';

export default {
  data() {
    return {
      phone: '+4797102265',
      token: '',
      step: 0,
      password: '666',
      showKeyboard: true,
      mnemonic: null,
    };
  },
  computed: {
    ...mapGetters({ wallet: 'Wallet/wallet' }),
    ...mapGetters('Wallet', ['progress', 'created', 'wallet']),
  },
  methods: {
    onInput(key) {
      this.password = (this.password + key).slice(0, 6);
    },
    onDelete() {
      this.password = this.password.slice(0, this.password.length - 1);
    },

    onPhoneInput(key) {
      this.phone = (this.phone + key).slice(0, 6);
    },
    onPhoneDelete() {
      this.phone = this.phone.slice(0, this.phone.length - 1);
    },

    toggleOtp() {
      this.step = 2;
    },
    async validateToken() {
      try {
        const jwt = await this.$store.dispatch(validateOtpInit(), { token: this.token, phone: this.phone });
        console.log(jwt);
        this.$router.push({ name: names.ORGANIZATIONS });
      } catch (error) {
        console.log('error', error);
        // this.$router.push({ name: names.ORGANIZATIONS });
      }
    },
    async createWallet(event) {
      event.preventDefault();
      this.mnemonic = await this.$store.dispatch(basePath(TRIGGER_WALLET_GENERATION), { password: this.password });
      this.step = 2;
    },
  },
};
</script>

<style scoped>
.pin-code {
  margin-top: 2em; margin-left: 1em; font-weight: bold; color: white;
}

.sms-section {
  margin-top:1em; margin-left:1em; color: white;
}

.section-header {
  font-weight: bold; text-decoration: underline;
}
</style>
